﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Infragistics.Controls.Menus;
using Infragistics.Windows;

namespace SelectNodeByIconClick
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            DataContext = new TreeViewModel();
        }

        private void Image_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            XamDataTreeNodeControl node = Utilities.GetAncestorFromType(sender as Image, typeof(XamDataTreeNodeControl), false) as XamDataTreeNodeControl;
            node.Node.IsActive = true;
            node.Node.IsSelected = true;
        }
    }

    public class TreeViewModel : PropertyChangedNotifier
    {
        private ObservableCollection<Folder> data;

        public TreeViewModel()
        {
            Data = new ObservableCollection<Folder>();

            for (int i = 0; i < 10; i++)
            {
                Folder f = new Folder
                {
                    ID = i,
                    Name = "Root " + i,
                    SubFolders = new ObservableCollection<Folder>()
                };

                for (int j = 0; j < 5; j++)
                {
                    f.SubFolders.Add(new Folder { ID = i + j, Name = "Sub " + i + " " + j });
                }

                Data.Add(f);
            }
        }

        public ObservableCollection<Folder> Data
        {
            get { return data; }
            set { data = value; OnPropertyChagned("Data"); }
        }

    }

    public class Folder : PropertyChangedNotifier
    {
        private int id;

        public int ID
        {
            get { return id; }
            set { id = value; OnPropertyChagned("ID"); }
        }

        private string name;

        public string Name
        {
            get { return name; }
            set { name = value; OnPropertyChagned("Name"); }
        }

        private ObservableCollection<Folder> subFolders;

        public ObservableCollection<Folder> SubFolders
        {
            get { return subFolders; }
            set { subFolders = value; OnPropertyChagned("SubFolders"); }
        }

    }

    public class PropertyChangedNotifier : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChagned(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }
}